Subject: Re: [PATCH] usb: add Freescale QE/CPM USB peripheral controller driver

From: Arnd Bergmann <[email-masked]>
Date: Fri, 29 Aug 2008 00:27:58 +0200

On Thursday 28 August 2008, Alan Stern wrote:
> On Thu, 28 Aug 2008, Scott Wood wrote:
> 
> > Alan Stern wrote:
> > > This was done deliberately.  The relevant standards state that a USB
> > > device can have no more than one peripheral interface.
> > 
> > Does building a kernel image that can run on different hardware without 
> > rebuilding also violate the "relevant standards"?
> 
> No.  That isn't what Arnd was concerned about.  He noted that even if 
> you did build multiple modules, only one of them could be loaded at any 
> time.

Well, actually it was exactly what I was concerned about ;-)

The way I understand the code, it is layered into the hardware specific
part and the protocol specific part, which are connected through
the interfaces I pointed out.

The standard requires that there can only be one protocol handler
per physical interface, which is a reasonable limitation.
However, what the Linux implementation actually enforces is
that there can only be one hardware specific driver built or loaded
into the kernel, which just looks like an arbitrary restriction
that does not actually help.

If the gadget hardware drivers were registering the device with a
gadget_bus_type, you could still enforce the "only one protocol"
rule by binding every protocol to every device in that bus type.

	Arnd <><